const { MessageEmbed, MessageActionRow, MessageButton, Client } = require('discord.js');




class $client extends Client {

  constructor(data) {

    super(data);

  }

  

}


const { Message } = require('discord.js');

class $message extends Message {

  constructor(data, client) {

    super(client, data, null);

  }
}
  async function $sendMessage(content, channel) {

    const message = await channel.send(content);

    return message;

  }


/**
 * Discord.js v13 için client eventlerini kullanan bir fonksiyon.
 * 
 * @param {Client} client - Discord botunuzun client objesi.
 * @param {string} eventName - Dinlenmesini istediğiniz event ismi.
 * @param {Function} eventFunction - Event tetiklendiğinde çalışacak olan fonksiyon.
 * @returns {void}
 */
function $clientEvent(client, eventName, eventFunction) {
  if (!(client instanceof Client)) {
    throw new TypeError('client bir Client objesi olmalıdır.');
  }

  if (typeof eventName !== 'string') {
    throw new TypeError('eventName bir string olmalıdır.');
  }

  if (typeof eventFunction !== 'function') {
    throw new TypeError('eventFunction bir fonksiyon olmalıdır.');
  }

  client.on(eventName, eventFunction);
}




class $embed {
  constructor(channel) {
    this.channel = channel;
      
    this.embed = new MessageEmbed();
    
  }

    
  title(title) {
    this.embed.setTitle(title);
    return this;
  }

  description(description) {
    this.embed.setDescription(description);
    return this;
  }

  URL(url) {
    this.embed.setURL(url);
    return this;
  }

  color(color) {
    this.embed.setColor(color);
    return this;
  }

  author(name, iconURL, url) {
    this.embed.setAuthor(name, iconURL, url);
    return this;
  }

  thumbnail(url) {
    this.embed.setThumbnail(url);
    return this;
  }

  field(name, value, inline = false) {
    this.embed.addField(name, value, inline);
    return this;
  }

  fields(...fields) {
    this.embed.addFields(...fields);
    return this;
  }

  image(url) {
    this.embed.setImage(url);
    return this;
  }

  footer(text, iconURL) {
    this.embed.setFooter(text, iconURL);
    return this;
  }

  timestamp(timestamp = Date.now()) {
    this.embed.setTimestamp(timestamp);
    return this;
  }

  send() {
    this.channel.send({ embeds: [this.embed] });
  }
    
 sendWithRow(row) {
this.channel.send({ embeds: [this.embed], components: [row]})
    
     }
  }   
   
    
    







// Bir buton oluşturmak için gerekli olan tüm fonksiyonlar

class $button {
  constructor(channel) {
      this.channel = channel
   this.button = new MessageButton();
      
  }
customId(id) {

    this.button.setCustomId(id);
return this
  }

  label(label) {

    this.button.setLabel(label);
return this
  }

  style(style) {

    this.button.setStyle(style);
return this
  }

  disabled(disabled) {

  this.button.setDisabled(disabled);
return this
  }

  emoji(emoji) {

    this.button.setEmoji(emoji);
return this
  }

  url(url) {

  this.button.setURL(url);
return this
  }
  
save() {
    const row = new MessageActionRow().addComponents(this.button)
    return row
}
  
}

// Örnek bir buton oluşturma



// Örnek bir action row oluşturma



// Butonu kullanarak mesaj gönderme




 



    


module.exports = { $message, $embed, $client, $sendMessage, $clientEvent, $button}